"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Trigger = exports.version = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

var _reactWidgetPopup = _interopRequireDefault(require("react-widget-popup"));

var _listen = _interopRequireDefault(require("dom-helpers/listen"));

var _contains = _interopRequireDefault(require("dom-helpers/contains"));

var _jqPosition = _interopRequireDefault(require("jq-position"));

var _reactWidgetPortal = _interopRequireDefault(require("react-widget-portal"));

var _getPlacement = _interopRequireDefault(require("./getPlacement"));

var isMobile = typeof navigator !== "undefined" && !!navigator.userAgent.match(/(Android|iPhone|iPad|iPod|iOS|UCWEB)/i);
var version = "2.0.0";
exports.version = version;

var Trigger = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2.default)(Trigger, _React$Component);

  function Trigger() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      popupVisible: _this.props.defaultPopupVisible
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "delayTimer", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "popupInstance", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "triggerInstance", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "refHandlers", {
      popup: function popup(node) {
        return _this.popupInstance = node;
      },
      trigger: function trigger(node) {
        return _this.triggerInstance = node;
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "clickOutsideHandler", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "touchOutsideHandler", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "contextMenuOutsideHandler1", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "contextMenuOutsideHandler2", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "windowScrollHandler", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "windowResizeHandler", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onDocumentClick", function (event) {
      var target = event.target;

      var triggerNode = _this.getTriggerNode();

      var popupRootNode = _this.popupInstance.getRootDOM();

      if (!(0, _contains.default)(triggerNode, target) && !(0, _contains.default)(popupRootNode, target)) {
        _this.hide();
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "isFocusToShow", function () {
      return _this.checkToShow(["focus"]);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "isBlurToHide", function () {
      return _this.checkToHide(["focus", "blur"]);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "isWindowResizeToHide", function () {
      return _this.checkToHide(["resize"]);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "isWindowScrollToHide", function () {
      return _this.checkToHide(["scroll"]);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onMouseEnter", function (e) {
      _this.delaySetPopupVisible(true);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onMouseLeave", function (e) {
      _this.delaySetPopupVisible(false);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onFocus", function (e) {
      _this.delaySetPopupVisible(true);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onBlur", function (e) {
      _this.delaySetPopupVisible(false);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onContextMenuClose", function () {
      _this.hide();
    });
    return _this;
  }

  Trigger.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, state) {
    return {
      popupVisible: nextProps.popupVisible === undefined ? state.popupVisible : nextProps.popupVisible
    };
  };

  var _proto = Trigger.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.togglePopupCloseEvents();
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.togglePopupCloseEvents();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.clearDelayTimer();
    this.clearOutsideHandler();
  };

  _proto.togglePopupCloseEvents = function togglePopupCloseEvents() {
    var _this2 = this;

    var getDocument = this.props.getDocument;
    var popupVisible = this.state.popupVisible;

    if (popupVisible) {
      var currentDocument = getDocument();

      if (!this.clickOutsideHandler && (this.isMouseDownToHide() || this.isClickToHide() || this.isContextMenuToShow())) {
        this.clickOutsideHandler = (0, _listen.default)(currentDocument, "mousedown", function (e) {
          //修复在Edge下如果点击Trigger并由上层组件隐藏Popup时，导致mouseup无法触发从而导致文字选择的BUG...
          //不在Trigger里修复，这部分需要由上层组件通过setTimeout方式延迟隐藏的方式来规避
          //e.preventDefault();
          _this2.onDocumentClick(e);
        });
      }

      if (!this.touchOutsideHandler && isMobile) {
        this.touchOutsideHandler = (0, _listen.default)(currentDocument, "click", this.onDocumentClick);
      } // close popup when trigger type contains 'onContextMenu' and document is scrolling.


      if (!this.contextMenuOutsideHandler1 && this.isContextMenuToShow()) {
        this.contextMenuOutsideHandler1 = (0, _listen.default)(currentDocument, "scroll", this.onContextMenuClose);
      } // close popup when trigger type contains 'onContextMenu' and window is blur.


      if (!this.contextMenuOutsideHandler2 && this.isContextMenuToShow()) {
        //@ts-ignore
        this.contextMenuOutsideHandler2 = (0, _listen.default)(window, "blur", this.onContextMenuClose);
      }

      if (!this.windowScrollHandler && this.isWindowScrollToHide()) {
        this.windowScrollHandler = (0, _listen.default)(currentDocument, "scroll", this.onDocumentClick);
      }

      if (!this.windowResizeHandler && this.isWindowResizeToHide()) {
        //@ts-ignore
        this.windowResizeHandler = (0, _listen.default)(window, "resize", this.hide.bind(this));
      }
    } else {
      this.clearOutsideHandler();
    }
  };

  _proto.getTriggerNode = function getTriggerNode() {
    return (0, _reactDom.findDOMNode)(this);
  };

  _proto.getComponentNode = function getComponentNode() {
    return (0, _reactDom.findDOMNode)(this);
  };

  _proto.clearOutsideHandler = function clearOutsideHandler() {
    if (this.clickOutsideHandler) {
      this.clickOutsideHandler();
      this.clickOutsideHandler = null;
    }

    if (this.contextMenuOutsideHandler1) {
      this.contextMenuOutsideHandler1();
      this.contextMenuOutsideHandler1 = null;
    }

    if (this.contextMenuOutsideHandler2) {
      this.contextMenuOutsideHandler2();
      this.contextMenuOutsideHandler2 = null;
    }

    if (this.touchOutsideHandler) {
      this.touchOutsideHandler();
      this.touchOutsideHandler = null;
    }

    if (this.windowScrollHandler) {
      this.windowScrollHandler();
      this.windowScrollHandler = null;
    }

    if (this.windowResizeHandler) {
      this.windowResizeHandler();
      this.windowResizeHandler = null;
    }
  };

  _proto._setPopupVisible = function _setPopupVisible(popupVisible) {
    var _this$props$onPopupVi, _this$props;

    if (!("popupVisible" in this.props)) {
      this.setState({
        popupVisible: popupVisible
      });
    }

    (_this$props$onPopupVi = (_this$props = this.props).onPopupVisibleChange) === null || _this$props$onPopupVi === void 0 ? void 0 : _this$props$onPopupVi.call(_this$props, popupVisible);
  };

  _proto.show = function show() {
    this.delaySetPopupVisible(true);
  };

  _proto.hide = function hide() {
    this.delaySetPopupVisible(false);
  };

  _proto.clearDelayTimer = function clearDelayTimer() {
    if (this.delayTimer) {
      clearTimeout(this.delayTimer);
      this.delayTimer = null;
    }
  };

  _proto.getDelayTime = function getDelayTime(action) {
    if (action === void 0) {
      action = "show";
    }

    var delay = this.props.delay;

    if (delay && typeof delay !== "number") {
      return Math.abs(delay[action]);
    }

    return Math.abs(delay);
  };

  _proto.delaySetPopupVisible = function delaySetPopupVisible(visible) {
    var _this3 = this;

    if (this.state.popupVisible === visible) {
      return;
    }

    this.clearDelayTimer();
    var delay = this.getDelayTime(visible ? "show" : "hide");

    if (delay) {
      this.delayTimer = setTimeout(function () {
        _this3.delayTimer = null;

        _this3._setPopupVisible(visible);
      }, delay);
    } else {
      this._setPopupVisible(visible);
    }
  };

  _proto.checkToShow = function checkToShow(actions) {
    var _this$props2 = this.props,
        action = _this$props2.action,
        showAction = _this$props2.showAction;
    var action1 = Array.isArray(action) ? action : [action];
    var showAction1 = Array.isArray(showAction) ? showAction : [showAction];
    var s = [].concat(action1, showAction1);

    for (var i = 0; i < actions.length; i++) {
      if (s.indexOf(actions[i]) !== -1) return true;
    }

    return false;
  };

  _proto.checkToHide = function checkToHide(actions) {
    var _this$props3 = this.props,
        action = _this$props3.action,
        hideAction = _this$props3.hideAction;
    var action1 = Array.isArray(action) ? action : [action];
    var hideAction1 = Array.isArray(hideAction) ? hideAction : [hideAction];
    var s = [].concat(action1, hideAction1);

    for (var i = 0; i < actions.length; i++) {
      if (s.indexOf(actions[i]) !== -1) return true;
    }

    return false;
  };

  _proto.isContextMenuToShow = function isContextMenuToShow() {
    return this.checkToShow(["contextMenu"]);
  };

  _proto.isMouseDownToShow = function isMouseDownToShow() {
    return this.checkToShow(["mouseDown"]);
  };

  _proto.isMouseDownToHide = function isMouseDownToHide() {
    return this.checkToHide(["mouseDown"]);
  };

  _proto.isClickToShow = function isClickToShow() {
    return this.checkToShow(["click"]);
  };

  _proto.isClickToHide = function isClickToHide() {
    return this.checkToHide(["click"]);
  };

  _proto.isMouseEnterToShow = function isMouseEnterToShow() {
    return this.checkToShow(["hover", "mouseEnter"]);
  };

  _proto.isMouseLeaveToHide = function isMouseLeaveToHide() {
    return this.checkToHide(["hover", "mouseLeave"]);
  };

  _proto.onContextMenu = function onContextMenu(e) {
    e.preventDefault();
    this.delaySetPopupVisible(true);
  };

  _proto.onTriggerClick = function onTriggerClick(e) {
    var nextVisible = !this.state.popupVisible;

    if (this.isClickToHide() && !nextVisible || nextVisible && this.isClickToShow()) {
      this.delaySetPopupVisible(nextVisible);
    }
  };

  _proto.onTriggerMouseDown = function onTriggerMouseDown(e) {
    var nextVisible = !this.state.popupVisible;

    if (this.isMouseDownToHide() && !nextVisible || nextVisible && this.isMouseDownToShow()) {
      this.delaySetPopupVisible(nextVisible);
    }
  };

  _proto.setPopupPosition = function setPopupPosition(dom) {
    var _this$props4 = this.props,
        placement = _this$props4.placement,
        offset = _this$props4.offset,
        positionOpts = _this$props4.position;
    (0, _jqPosition.default)(dom, Object.assign(Object.assign({}, (0, _getPlacement.default)(placement, offset)), {}, {
      collision: "flipfit",
      of: this.getTriggerNode()
    }, positionOpts));
  };

  _proto.getPopupComponent = function getPopupComponent() {
    var _this4 = this;

    var _this$props5 = this.props,
        popup = _this$props5.popup,
        prefixCls = _this$props5.prefixCls,
        popupClassName = _this$props5.popupClassName,
        popupMaskClassName = _this$props5.popupMaskClassName,
        popupProps = _this$props5.popupProps,
        popupMaskProps = _this$props5.popupMaskProps,
        popupTransition = _this$props5.popupTransition,
        popupMaskTransition = _this$props5.popupMaskTransition,
        forceRender = _this$props5.forceRender,
        mask = _this$props5.mask,
        disableMask = _this$props5.disableMask,
        maskClosable = _this$props5.maskClosable,
        popupStyle = _this$props5.popupStyle,
        popupMaskStyle = _this$props5.popupMaskStyle,
        destroyPopupOnHide = _this$props5.destroyPopupOnHide,
        zIndex = _this$props5.zIndex,
        popupRootClassName = _this$props5.popupRootClassName,
        popupRootStyle = _this$props5.popupRootStyle,
        onBeforeShow = _this$props5.onBeforeShow,
        onAfterShow = _this$props5.onAfterShow,
        onBeforeHide = _this$props5.onBeforeHide,
        onAfterHide = _this$props5.onAfterHide;
    var popupVisible = this.state.popupVisible;
    var newPopupStyle = Object.assign({}, popupStyle);
    var newPopupMaskStyle = Object.assign({}, popupMaskStyle);

    if (zIndex != null) {
      newPopupStyle.zIndex = zIndex;
      newPopupMaskStyle.zIndex = zIndex;
    }

    return /*#__PURE__*/_react.default.createElement(_reactWidgetPopup.default, (0, _extends2.default)({
      ref: this.refHandlers.popup,
      prefixCls: prefixCls,
      destroyOnClose: destroyPopupOnHide,
      style: newPopupStyle,
      className: popupClassName,
      maskClassName: popupMaskClassName,
      maskStyle: newPopupMaskStyle,
      mask: mask,
      disableMask: disableMask,
      rootClassName: popupRootClassName,
      rootStyle: popupRootStyle,
      forceRender: forceRender
    }, popupProps, {
      fixed: false,
      visible: popupVisible,
      transition: Object.assign(Object.assign({}, popupTransition), {}, {
        onEnter: function onEnter(dom, appearing) {
          var _popupTransition$onEn;

          onBeforeShow === null || onBeforeShow === void 0 ? void 0 : onBeforeShow(dom);

          _this4.setPopupPosition(dom);

          popupTransition === null || popupTransition === void 0 ? void 0 : (_popupTransition$onEn = popupTransition.onEnter) === null || _popupTransition$onEn === void 0 ? void 0 : _popupTransition$onEn.call(popupTransition, dom, appearing);
        },
        onEntered: function onEntered(dom, appearing) {
          var _popupTransition$onEn2;

          _this4.setPopupPosition(dom);

          popupTransition === null || popupTransition === void 0 ? void 0 : (_popupTransition$onEn2 = popupTransition.onEntered) === null || _popupTransition$onEn2 === void 0 ? void 0 : _popupTransition$onEn2.call(popupTransition, dom, appearing);
          onAfterShow === null || onAfterShow === void 0 ? void 0 : onAfterShow(dom);
        },
        onExit: function onExit(dom) {
          var _popupTransition$onEx;

          onBeforeHide === null || onBeforeHide === void 0 ? void 0 : onBeforeHide(dom);
          popupTransition === null || popupTransition === void 0 ? void 0 : (_popupTransition$onEx = popupTransition.onExit) === null || _popupTransition$onEx === void 0 ? void 0 : _popupTransition$onEx.call(popupTransition, dom);
        },
        onExited: function onExited(dom) {
          var _popupTransition$onEx2;

          onAfterHide === null || onAfterHide === void 0 ? void 0 : onAfterHide(dom);
          popupTransition === null || popupTransition === void 0 ? void 0 : (_popupTransition$onEx2 = popupTransition.onExit) === null || _popupTransition$onEx2 === void 0 ? void 0 : _popupTransition$onEx2.call(popupTransition, dom);
        }
      }),
      onMouseEnter: function onMouseEnter(e) {
        var _popupProps$onMouseEn;

        _this4.clearDelayTimer();

        popupProps === null || popupProps === void 0 ? void 0 : (_popupProps$onMouseEn = popupProps.onMouseEnter) === null || _popupProps$onMouseEn === void 0 ? void 0 : _popupProps$onMouseEn.call(popupProps, e);
      },
      onMouseLeave: function onMouseLeave(e) {
        var _popupProps$onMouseLe;

        if (_this4.isMouseLeaveToHide()) {
          _this4.onMouseLeave(e);
        }

        popupProps === null || popupProps === void 0 ? void 0 : (_popupProps$onMouseLe = popupProps.onMouseLeave) === null || _popupProps$onMouseLe === void 0 ? void 0 : _popupProps$onMouseLe.call(popupProps, e);
      },
      maskTransition: popupMaskTransition,
      maskProps: Object.assign(Object.assign({}, popupMaskProps), {}, {
        onClick: function onClick(e) {
          var _popupMaskProps$onCli;

          if (maskClosable) {
            _this4.hide();
          }

          popupMaskProps === null || popupMaskProps === void 0 ? void 0 : (_popupMaskProps$onCli = popupMaskProps.onClick) === null || _popupMaskProps$onCli === void 0 ? void 0 : _popupMaskProps$onCli.call(popupMaskProps, e);
        },
        onMouseEnter: function onMouseEnter(e) {
          var _popupMaskProps$onMou;

          _this4.clearDelayTimer();

          popupMaskProps === null || popupMaskProps === void 0 ? void 0 : (_popupMaskProps$onMou = popupMaskProps.onMouseEnter) === null || _popupMaskProps$onMou === void 0 ? void 0 : _popupMaskProps$onMou.call(popupMaskProps, e);
        }
      })
    }), typeof popup === "function" ? popup(this) : popup);
  };

  _proto.genNewChildProps = function genNewChildProps(child) {
    var _this5 = this;

    var checkDefaultPrevented = this.props.checkDefaultPrevented;
    var newChildProps = {};

    if (this.isContextMenuToShow()) {
      newChildProps.onContextMenu = function (e) {
        if (child.props.onContextMenu) {
          child.props.onContextMenu(e);
        }

        if (checkDefaultPrevented && e.defaultPrevented) return;

        _this5.clearDelayTimer();

        _this5.onContextMenu(e);
      };
    }

    if (this.isMouseDownToShow() || this.isMouseDownToHide()) {
      newChildProps.onMouseDown = function (e) {
        if (child.props.onMouseDown) {
          child.props.onMouseDown(e);
        }

        if (checkDefaultPrevented && e.defaultPrevented) return;

        _this5.clearDelayTimer();

        _this5.onTriggerMouseDown(e);
      };
    }

    if (this.isClickToHide() || this.isClickToShow()) {
      newChildProps.onClick = function (e) {
        if (child.props.onClick) {
          child.props.onClick(e);
        }

        if (checkDefaultPrevented && e.defaultPrevented) return;

        _this5.clearDelayTimer();

        _this5.onTriggerClick(e);
      };
    }

    if (this.isMouseEnterToShow()) {
      newChildProps.onMouseEnter = function (e) {
        if (child.props.onMouseEnter) {
          child.props.onMouseEnter(e);
        }

        if (checkDefaultPrevented && e.defaultPrevented) return;

        _this5.clearDelayTimer();

        _this5.onMouseEnter(e);
      };
    }

    if (this.isMouseLeaveToHide()) {
      newChildProps.onMouseLeave = function (e) {
        if (child.props.onMouseLeave) {
          child.props.onMouseLeave(e);
        }

        if (checkDefaultPrevented && e.defaultPrevented) return;

        _this5.clearDelayTimer();

        _this5.onMouseLeave(e);
      };
    }

    if (this.isFocusToShow()) {
      newChildProps.onFocus = function (e) {
        if (child.props.onFocus) {
          child.props.onFocus(e);
        }

        if (checkDefaultPrevented && e.defaultPrevented) return;

        _this5.clearDelayTimer();

        _this5.onFocus(e);
      };
    }

    if (this.isBlurToHide()) {
      newChildProps.onBlur = function (e) {
        if (child.props.onBlur) {
          child.props.onBlur(e);
        }

        if (checkDefaultPrevented && e.defaultPrevented) return;

        _this5.clearDelayTimer();

        _this5.onBlur(e);
      };
    }

    return newChildProps;
  };

  _proto.render = function render() {
    var _this$props6 = this.props,
        usePortal = _this$props6.usePortal,
        container = _this$props6.container;

    var child = _react.default.Children.only(this.props.children);

    var trigger = _react.default.cloneElement(child, this.genNewChildProps(child));

    var popup = this.getPopupComponent();

    if (usePortal) {
      popup = /*#__PURE__*/_react.default.createElement(_reactWidgetPortal.default, {
        container: container
      }, popup);
    }

    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, trigger, popup);
  };

  return Trigger;
}(_react.default.Component);

exports.Trigger = Trigger;
(0, _defineProperty2.default)(Trigger, "defaultProps", {
  prefixCls: "rw-trigger",
  placement: "bottomLeft",
  offset: 0,
  defaultPopupVisible: false,
  action: ["click"],
  showAction: [],
  hideAction: [],
  delay: 0,
  getDocument: function getDocument() {
    return window.document;
  },
  container: document.body,
  mask: false,
  maskClosable: true,
  destroyPopupOnHide: true,
  popupProps: {},
  popupStyle: {},
  popupMaskStyle: {},
  checkDefaultPrevented: false,
  usePortal: true
});
var _default = Trigger;
exports.default = _default;